package name.panitz.util;
import static name.panitz.util.LL.*;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

import java.util.Arrays;
import java.util.Collection;

import org.junit.Before;
import org.junit.Test;

public class LLTest {
  
  LL<String> xs;
  LL<String> ys;
  LL<Integer> is;
  LL<Integer> is2;
  int i = 0;

 
  
  @Before
  public void setUp() throws Exception {
    xs = nil();
    ys = nil();
    is = nil();
    is2 = nil();
    i = 0;
    CounterFields.resetCounters();
  }

  @Test
  public void tesBinSearch1() {
    int[] xs = {1,2,3,4,5,6,7,8,9,10};
    assertEquals(")",2,binSearch(3,xs));
  }
  @Test
  public void tesBinSearch1Complexity() {
    int[] xs = {1,2,3,4,5,6,7,8,9,10};
    binSearch(3,xs);
    assertTrue("counting binSearch Aufrufe",2>=CounterFields.binSearchIterationCount);
  }
  @Test
  public void tesBinSearch2Complexity() {
    int[] xs = {1,2,3,4,5,6,7,8,9,10};
    binSearch(12,xs);
    assertTrue("counting binSearch Aufrufe",5>=CounterFields.binSearchIterationCount);
  }
  @Test
  public void testLength1() {
    assertEquals("nil().length()",0,nil().length());
  }

  @Test
  public void testLength2() {
    assertEquals("of(42).length()",1,of(42).length());
  }
  @Test
  public void testLength2Complexity() {
    of(42).length();
    assertTrue("counting length Aufrufe",2>=CounterFields.lengthInvocationCount);
    assertEquals("die Funktion sollte rekursiv sein und nicht die iterative aufrufen",0,CounterFields.lengthItInvocationCount);
    assertTrue("die Funktion sollte rekursiv seibn, scheint aber eine SChleife zu enthalten",2>=CounterFields.lengthIterationCount);
  }
  @Test
  public void testLength3() {
    assertEquals("of(1,2,3,4,5).length()",5,of(1,2,3,4,5).length());
  }
  @Test
  public void testLength3Complexity() {
    of(1,2,3,4,5).length();
    assertTrue("counting length Aufrufe",6>=CounterFields.lengthInvocationCount);
    assertEquals("die Funktion sollte rekursiv sein und nicht die iterative aufrufen",0,CounterFields.lengthItInvocationCount);
    assertTrue("die Funktion sollte rekursiv sein, scheint aber eine SChleife zu enthalten",2>=CounterFields.lengthIterationCount);
  }
  @Test
  public void testLengthIt1() {
    assertEquals("nil().lengthIt()",0,nil().lengthIt());
  }

  @Test
  public void testLengthIt2() {
    assertEquals("of(42).lengthIt()",1,of(42).lengthIt());
  }
  @Test
  public void testLengthIt2Complexity() {
    of(42,16).lengthIt();
    assertEquals("die Funktion sollte iterative sein und nicht sich rekursiv aufrufen",1,CounterFields.lengthItInvocationCount);
    assertEquals("die Funktion sollte iterative sein und nicht die rekursive aufrufen",0,CounterFields.lengthInvocationCount);
    assertTrue("die Funktion scheint zu wenig die Schleife zu durchlaufen: "+CounterFields.lengthItIterationCount,4>=CounterFields.lengthItIterationCount);
    assertTrue("die Funktion scheint zu of die Schleife zu durchlaufen: "+CounterFields.lengthItIterationCount,2<=CounterFields.lengthItIterationCount);
  }
  @Test
  public void testLengthIt3() {
    assertEquals("of(1,2,3,4,5).lengthIt()",5,of(1,2,3,4,5).lengthIt());
  }
  @Test
  public void testLengthIt3Complexity() {
    of(1,2,3,4,5).lengthIt();
    assertEquals("die Funktion sollte iterative sein und nicht sich rekursiv aufrufen",1,CounterFields.lengthItInvocationCount);
    assertEquals("die Funktion sollte iterative sein und nicht die rekursive aufrufen",0,CounterFields.lengthInvocationCount);
    assertTrue("die Funktion scheint zu wenig die Schleife zu durchlaufen: "+CounterFields.lengthItIterationCount,6>=CounterFields.lengthItIterationCount);
    assertTrue("die Funktion scheint zu oft die Schleife zu durchlaufen: "+CounterFields.lengthItIterationCount,4<=CounterFields.lengthItIterationCount);
  }

  @Test
  public void testAppen1() {
    assertEquals("nil().append(nil())",nil(),nil().append(nil()));
  }

  @Test
  public void testAppend2() {
    assertEquals("of(1).append(nil())",of(1),of(1).append(nil()));
  }
  @Test
  public void testAppend3() {
    assertEquals("of(1).append(of(2,3,4))",of(1,2,3,4),of(1).append(of(2,3,4)));
  }
  @Test
  public void testAppend4() {
    assertEquals("of(1).append(nil())",of(1),of(1).append(nil()));
  }
  @Test
  public void testAppend5() {
    assertEquals("of(1,2,3,4).append(of(2,3,4))",of(1,2,3,4,2,3,4),of(1,2,3,4).append(of(2,3,4)));
  }

  @Test
  public void testAppen1Complexity() {
    nil().append(nil());
    assertTrue("counting append Aufrufe",1>=CounterFields.appendInvocationCount);
  }

  @Test
  public void testAppend2Complexity() {
    of(1).append(nil());
    assertTrue("counting append Aufrufe",2>=CounterFields.appendInvocationCount);
  }
  @Test
  public void testAppend3Complexity() {
    of(1).append(of(2,3,4));
    assertTrue("counting append Aufrufe",2>=CounterFields.appendInvocationCount);
  }
  @Test
  public void testAppend5Complexity() {
    of(1,2,3,4).append(of(2,3,4));
    assertTrue("counting append Aufrufe",5>=CounterFields.appendInvocationCount);
  }


  @Test
  public void last1() {
    xs = LL.of("A","B","C","D","E","F","G");
    assertEquals("","G",xs.last());
  }

  @Test
  public void last2() {
    xs = LL.of("A");
    assertEquals("","A",xs.last());
  }


  @Test
  public void append1() {
    xs = LL.of("A","B","C","D","E","F","G");
    assertEquals("",xs,xs.append(ys));
    assertEquals("",xs,ys.append(xs));
  }
  @Test
  public void append2() {
    xs = LL.of("A","B","C");
    ys = LL.of("D","E","F","G");
    assertEquals("",LL.of("A","B","C","D","E","F","G"),xs.append(ys));
  }



  @Test
  public void testDrop2() {
    xs = LL.of("A","B","C","D","E","F","G");
    assertEquals("falsches Ergebnis für: " + xs + ".drop(0)", xs, xs.drop(0));
  }
  @Test
  public void testDrop3() {
    xs = LL.of("A","B","C","D","E","F","G");
    assertEquals("falsches Ergebnis für: " + xs + ".drop(10)", ys, xs.drop(10));
  }

  @Test
  public void testTake1() {
    xs = LL.of("A","B","C","D","E","F","G");
    ys = LL.of("A","B","C");
    assertEquals("falsches Ergebnis für: " + xs + ".take(3)", ys, xs.take(3));
  }
  
  @Test
  public void testTake2() {
    xs = LL.of("A","B","C","D","E","F","G");
    assertEquals("falsches Ergebnis für: " + xs + ".take(0)", ys, xs.take(0));
  }
  @Test
  public void testTake3() {
    xs = LL.of("A","B","C","D","E","F","G");
    assertEquals("falsches Ergebnis für: " + xs + ".take(10)", xs, xs.take(10));
  }
  
  
  @Test
  public void testSublist1() {
    xs = LL.of("A","B","C","D","E","F","G");
    ys = LL.of("C","D","E");
    assertEquals("falsches Ergebnis für: " + xs + ".sublist(2,3)", ys, xs.sublist(2, 3));
  }

  @Test
  public void testSublist2() {
    assertEquals("falsches Ergebnis für sublist auf leerer Liste", nil(), xs.sublist(2, 4));
  }

}
